package org.zheng.demo;

import java.util.ArrayList;
import java.util.List;

public class BacktrackImpl extends BaseClass {

	private void backTrack(final String rawNumString, final int index, final String current, final int cnt,
			final List<String> results) {

		String temp = "";
		if (index >= rawNumString.length()) {
			return;
		}

		if (cnt == IP_V4_SEGMENT_COUNT - 1) {
			temp = rawNumString.substring(index);
			if (temp.length() <= IP_V4_SEGMENT_COUNT - 1 && isValidOctet(temp)) {
				results.add(current + temp);
			}
			return;
		}

		for (int i = index; i < Math.min(index + IP_V4_SEGMENT_COUNT - 1, rawNumString.length()); i++) {
			temp += rawNumString.charAt(i);
			if (isValidOctet(temp)) {
				backTrack(rawNumString, i + 1, current + temp + IPV4_SEPARATOR, cnt + 1, results);
			}
		}

	}

	public List<String> parseIpAddress(final String rawString) {
		List<String> parsedOutIps = new ArrayList<>();
		if (isValidIpv4NumericString(rawString)) {
			backTrack(rawString, 0, "", 0, parsedOutIps);
		}
		return parsedOutIps;
	}
}
