package org.zheng.demo;

import java.util.List;

public abstract class BaseClass {

	protected static final int IP_V4_SEGMENT_COUNT = 4;
	protected static final String IPV4_SEPARATOR = ".";
	private static final int MAX_IP_SEGMENT_VALUE = 255;
	private static final int MIN_IP_SEGMENT_VALUE = 0;
	private static final String ZERO = "0";

	public BaseClass() {
		super();
	}

	protected boolean isValidOctet(final String segment) {
		// Leading zeros are not allowed unless it's just "0"
		if (segment.length() > 1 && segment.startsWith(ZERO)) {
			return false;
		}

		int num = Integer.parseInt(segment);
		return num >= MIN_IP_SEGMENT_VALUE && num <= MAX_IP_SEGMENT_VALUE;
	}

	protected boolean isValidIpv4NumericString(final String rawIpNumber) {
		return rawIpNumber.length() >= 1 && rawIpNumber.length() <= 12;
	}

	public abstract List<String> parseIpAddress(final String rawString);

}