package org.zheng.demo;

import java.util.ArrayList;
import java.util.List;

public class DynamicImpl extends BaseClass {

	private void generate(final String rawNumString, final int position, final List<String> current,
			final List<String> results) {

		if (current.size() == IP_V4_SEGMENT_COUNT) {
			if (position == rawNumString.length()) {
				results.add(String.join(IPV4_SEPARATOR, current));
			}
			return;
		}

		for (int j = 1; j <= IP_V4_SEGMENT_COUNT - 1; j++) {
			int tempP = position + j;
			if (tempP > rawNumString.length()) {
				break;
			}

			String segment = rawNumString.substring(position, tempP);
			if (isValidOctet(segment)) {
				current.add(segment);
				generate(rawNumString, position + j, current, results);
				current.remove(current.size() - 1);
			}
		}
	}

	public List<String> parseIpAddress(final String rawString) {
		List<String> parsedOutIps = new ArrayList<>();
		if (isValidIpv4NumericString(rawString)) {
			generate(rawString, 0, new ArrayList<>(), parsedOutIps);
		}
		return parsedOutIps;
	}
}
