package org.zheng.demo;

import java.util.ArrayList;
import java.util.List;

public class IterativeImpl extends BaseClass {

	@Override
	public List<String> parseIpAddress(String rawString) {
		List<String> result = new ArrayList<>();
		if (isValidIpv4NumericString(rawString)) {

			int rawStringLength = rawString.length();

			// Try all 4 possible splits for each segment of the IP address
			for (int i = 1; i < Math.min(IP_V4_SEGMENT_COUNT, rawStringLength); i++) {
				for (int j = i + 1; j < Math.min(i + IP_V4_SEGMENT_COUNT, rawStringLength); j++) {
					for (int k = j + 1; k < Math.min(k + IP_V4_SEGMENT_COUNT, rawStringLength); k++) {
						// Split the string into 4 parts
						String part1 = rawString.substring(0, i);
						String part2 = rawString.substring(i, j);
						String part3 = rawString.substring(j, k);
						String part4 = rawString.substring(k);

						// Check if each part is a valid IP segment
						if (isValidOctet(part1) && isValidOctet(part2) && isValidOctet(part3) && isValidOctet(part4)) {
							// If all parts are valid, join them with a dot and add to the result
							result.add(
									part1 + IPV4_SEPARATOR + part2 + IPV4_SEPARATOR + part3 + IPV4_SEPARATOR + part4);
						}
					}
				}
			}
		}
		return result;
	}
}
