package org.zheng.demo;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.util.List;

import org.junit.jupiter.api.Test;

public abstract class BaseTest {

	protected BaseClass testClass;

	@Test
	void test_isValid_for_bad_larger() {
		assertFalse(testClass.isValidOctet("256"));
	}

	@Test
	void test_isValid_for_bad_startzero() {
		assertFalse(testClass.isValidOctet("01"));
	}

	@Test
	void test_isValid_for_bad_startzeroo() {
		assertFalse(testClass.isValidOctet("001"));
	}

	@Test
	void test_isValid_for_good() {
		for (int i = 0; i <= 255; i++) {
			assertTrue(testClass.isValidOctet("0"));
		}
	}

	@Test
	void testParseIpAddress() {
		List<String> possibleIps = testClass.parseIpAddress("196255111253");
		assertEquals(1, possibleIps.size());
		assertEquals("196.255.111.253", possibleIps.get(0));
	}

	@Test
	void testParseIpAddress_bad_0() {
		List<String> possibleIps = testClass.parseIpAddress("12");
		assertEquals(0, possibleIps.size());
	}

	@Test
	void testParseIpAddress_bad_1() {
		List<String> possibleIps = testClass.parseIpAddress("25825511135");
		assertEquals(0, possibleIps.size());
	}

	@Test
	void testParseIpAddress_bad_2() {
		List<String> possibleIps = testClass.parseIpAddress("25505011535");
		assertEquals(0, possibleIps.size());
	}

	@Test
	void testParseIpAddress_bad_3() {
		List<String> possibleIps = testClass.parseIpAddress("25505011535666");
		assertEquals(0, possibleIps.size());
	}

	@Test
	void testParseIpAddress2() {
		List<String> possibleIps = testClass.parseIpAddress("25525511135");
		assertEquals(2, possibleIps.size());
		assertTrue(possibleIps.contains("255.255.11.135"));
		assertTrue(possibleIps.contains("255.255.111.35"));
	}

}